con
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  SDpinBase = 0

  SEARCH = $ff
  GETSIZE_0 = 0
  GETSIZE_1 = 1
  GETSIZE_2 = 2
  GETSIZE_3 = 3
  

obj
  IO: "CogOS_IO(Term)"
  sdfat: "fsrw"

var
  long  size
  byte  buffer[1024]
  
pub main | filepos, offset, sstr, tmp, state
  IO.start( 0, 0 )
  IO.str(string("Welcome to Filesearch 0.9",13))

  sdfat.mount( SDpinBase )

  ' this prepares a file to contain some search-strings
  sdfat.vOpenSwap( 0, string( "SWAP3.SYS" ))
  sdfat.vwMemCopyNL( 0, 510, @searchstr, 4 )
  sdfat.vwMemCopyNL( 0, 2048, @searchstr+8, 4 )
  sdfat.vwMemCopyNL( 0, 4094, @searchstr+16, 4 )
  sdfat.vMemFlush( 0 )

  ' now let FSRW open the file for read from beginning
  sdfat.popen( string( "SWAP3.SYS" ), "r" )
  IO.dec( sdfat.get_filesize )
  IO.tx( 13 )
  
  offset:=-1
  state:=$ff
  
  ' loop over 6000 bytes ... other criteria could be: loop as long as not all
  ' searchstrings have been found ...
  repeat filepos from 0 to 6000
    ' do the offset calculation and load buffer, if needed
    offset := (offset+1) & $3ff
    if (offset & $1ff) == 0
      if offset & $200
        ' load into upper part of buffer
        sdfat.pread( @buffer+512, 512 )
      else
        ' load into lower paart of buffer
        sdfat.pread( @buffer, 512 )

    ' get the size by running into this 4 times
    ' this way the outer loop can still do the offset-increment and the buffer-load
    if state<>$ff
      ' this is for LSB first file format - otherwise do (3-state)<<3 instead
      size|=buffer[ offset ]<<(state<<3)
      state ++
      ' if state equals 4 all 4 bytes have been read
      if state==4
        state:=$ff
        IO.tx( 13 )
        IO.hex( size, 8 )
        IO.tx( 13 )

    ' this is only for printing the file-content          
    IO.hex( buffer[ offset ], 2 )
    IO.tx(" ")
    if (offset // 32)==31
      IO.tx( 13 )

    ' loop over all search-strings
    repeat sstr from 0 to 2
      ' calculate the base address of the actual search-string
      tmp:=@searchstr + sstr<<3  ' => sstr * 8
      ' if the current character in the buffer equals the actual character of the
      ' search-string
      if buffer[ offset ]==byte[ tmp ][ byte[ tmp ][ 6 ] ]
        ' increase the match counter
        byte[ tmp ][ 6 ]++

        ' if match counter equals search string length, we found the string
        if byte[ tmp ][ 6 ] == byte[ tmp ][ 5 ]
          state := 0
          size := 0
          IO.tx( 13 )
          IO.str(string("found searchstring "))
          IO.dec( sstr )
          IO.tx( 13 )
      else
        ' mismatch found, so reset actual searchstring position
        byte[ tmp ][ 6 ]:=0

  repeat
      
dat

 ' null terminated string, length, matchcounter, just for long alignment ... not really needed
searchstr
  byte "@nam",0,4,0,0
  byte "@art",0,4,0,0
  byte "@alb",0,4,0,0
  